package loopbounds;

import java.lang.reflect.Method;

/** 
 * Testing is done in a separate thread, to ensure that the
 * prototype does not crash when a loop runs indefinitely on certain input.
 * 
 * @author Rody Kersten
 *
 */
public class MethodInvocationThread extends Thread {

    private Method m;
    private Object classInstance;
    private Object[] args;
    public Integer returnVal;
    
    /** Constructor.
     * 
     * @param m The method to run
     * @param classInstance The class in which the method resides
     * @param args The parameters to the method
     */
    public MethodInvocationThread(Method m, Object classInstance, Object[] args) {
    	this.m = m;
    	this.classInstance = classInstance;
    	this.args = args;
    	this.returnVal = -1;
    }
  
    /** Run the thread! */
    public void run() {

        try {
            returnVal = (Integer) m.invoke(classInstance, args);
        } catch (Exception e) {
        	e.printStackTrace();
        }

    }
}
