package loopbounds.parsetree;

/** Exception for when a type is used in the loop condition that
 * is not (yet) supported by the prototype.
 * 
 * @author Rody Kersten
 *
 */
public class UnsupportedTypeException extends Exception {
	static final long serialVersionUID = 203;
	
	private String type;
	
	/** Constructor.
	 * 
	 * @param type A string representation of the unsupported type.
	 */
	public UnsupportedTypeException(String type) {
		this.type = type;
	}
	
	/** Get a String explaining the exception.
	 * @return A string which explains why the exception occurred to the user.
	 */
	@Override
	public String toString() {
		return new String("The type '" + type + "' is not supported by the prototype yet!");
	}
}