package resanaplugin;

import org.eclipse.jdt.core.Flags;
import org.eclipse.jdt.core.IMethod;
import org.eclipse.jdt.core.JavaModelException;

public class Method {
	
	IMethod method;
	String signature;
	
	public Method(IMethod method, String signature){
		this.method = method;
		this.signature = signature;
	}
	
	public IMethod getMethod(){
		return method;
	}
	
	public String getMethodSignature(boolean showProtection){
		try {
			String protection = "";
			if (showProtection) {
				int flags = method.getFlags();
				if (Flags.isPublic(flags))
					protection = "+ ";
				else if (Flags.isPrivate(flags))
					protection = "- ";
				else if (Flags.isProtected(flags))
					protection = "# ";
			}
			return protection + signature;
		} catch (JavaModelException e) {
			e.printStackTrace();
		}
		return null;
	}

}
