package resanaplugin.costa;

import org.jmlspecs.openjml.JmlToken;
import org.jmlspecs.openjml.JmlTree.JmlMethodClauseConditional;
import org.jmlspecs.openjml.JmlTreeScanner;

import com.sun.tools.javac.tree.JCTree;

public class MeasureByScanner extends JmlTreeScanner {
	private JmlMethodClauseConditional measuredByClause;

	private MeasureByScanner() {
	}

	/**
	 * Returns the first measured by in the tree
	 * 
	 * @return measured by clause
	 */
	public static JmlMethodClauseConditional findMeasuredBy(JCTree tree) {
		MeasureByScanner scanner = new MeasureByScanner();
		scanner.scan(tree);
		return scanner.measuredByClause;
	}

	@Override
	public void visitJmlMethodClauseConditional(JmlMethodClauseConditional tree) {
		if (tree.token.equals(JmlToken.MEASURED_BY) && measuredByClause == null) {
			measuredByClause = tree;
		}
		super.visitJmlMethodClauseConditional(tree);
	}
}
